<?php
/**
 * Safety Wear Theme Customizer.
 *
 * @link https://developer.wordpress.org/themes/basics/theme-functions/
 *
 * @package safety_wear
 */

if( ! function_exists( 'safety_wear_customize_register' ) ):  
/**
 * Add postMessage support for site title and description for the Theme Customizer.F
 *
 * @param WP_Customize_Manager $wp_customize Theme Customizer object.
 */
function safety_wear_customize_register( $wp_customize ) {

    require get_parent_theme_file_path('/inc/controls/sortable-control.php');
    
    //Register the sortable control type.
    $wp_customize->register_control_type( 'Safety_Wear_Control_Sortable' ); 
    if ( version_compare( get_bloginfo('version'),'4.9', '>=') ) {
        $wp_customize->get_section( 'static_front_page' )->title = __( 'Static Front Page', 'safety-wear' );
    }
	
    /* Option list of all post */	
    $safety_wear_options_posts = array();
    $safety_wear_options_posts_obj = get_posts('posts_per_page=-1');
    $safety_wear_options_posts[''] = esc_html__( 'Choose Post', 'safety-wear' );
    foreach ( $safety_wear_options_posts_obj as $safety_wear_posts ) {
    	$safety_wear_options_posts[$safety_wear_posts->ID] = $safety_wear_posts->post_title;
    }
    
    /* Option list of all categories */
    $safety_wear_args = array(
	   'type'                     => 'post',
	   'orderby'                  => 'name',
	   'order'                    => 'ASC',
	   'hide_empty'               => 1,
	   'hierarchical'             => 1,
	   'taxonomy'                 => 'category'
    ); 
    $safety_wear_option_categories = array();
    $safety_wear_category_lists = get_categories( $safety_wear_args );
    $safety_wear_option_categories[''] = esc_html__( 'Choose Category', 'safety-wear' );
    foreach( $safety_wear_category_lists as $safety_wear_category ){
        $safety_wear_option_categories[$safety_wear_category->term_id] = $safety_wear_category->name;
    }
    
    /** Default Settings */    
    $wp_customize->add_panel( 
        'wp_default_panel',
         array(
            'priority' => 10,
            'capability' => 'edit_theme_options',
            'theme_supports' => '',
            'title' => esc_html__( 'Default Settings', 'safety-wear' ),
            'description' => esc_html__( 'Default section provided by wordpress customizer.', 'safety-wear' ),
        ) 
    );
    
    $wp_customize->get_section( 'title_tagline' )->panel                  = 'wp_default_panel';
    $wp_customize->get_section( 'colors' )->panel                         = 'wp_default_panel';
    $wp_customize->get_section( 'header_image' )->panel                   = 'wp_default_panel';
    $wp_customize->get_section( 'background_image' )->panel               = 'wp_default_panel';
    $wp_customize->get_section( 'static_front_page' )->panel              = 'wp_default_panel';
    
    $wp_customize->get_setting( 'blogname' )->transport         = 'postMessage';
	$wp_customize->get_setting( 'blogdescription' )->transport  = 'postMessage';
	$wp_customize->get_setting( 'header_textcolor' )->transport = 'postMessage';
    
    /** Default Settings Ends */

     /** Site Title control */
    $wp_customize->add_setting( 
        'header_site_title', 
        array(
            'default'           => false,
            'sanitize_callback' => 'safety_wear_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'header_site_title',
        array(
            'label'       => __( 'Show / Hide Site Title', 'safety-wear' ),
            'section'     => 'title_tagline',
            'type'        => 'checkbox',
        )
    );

    /** Tagline control */
    $wp_customize->add_setting( 
        'header_tagline', 
        array(
            'default'           => false,
            'sanitize_callback' => 'safety_wear_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'header_tagline',
        array(
            'label'       => __( 'Show / Hide Tagline', 'safety-wear' ),
            'section'     => 'title_tagline',
            'type'        => 'checkbox',
        )
    );

    $wp_customize->add_setting('logo_width', array(
        'sanitize_callback' => 'absint', 
    ));

    // Add a control for logo width
    $wp_customize->add_control('logo_width', array(
        'label' => __('Logo Width', 'safety-wear'),
        'section' => 'title_tagline',
        'type' => 'number',
        'input_attrs' => array(
            'min' => '50', 
            'max' => '500', 
            'step' => '5', 
    ),
        'default' => '100', 
    ));

        /** Responsive Media settings */
    
    $wp_customize->add_section(
        'safety_wear_responsive_media_section',
        array(
            'title' => esc_html__( 'Responsive Media Settings', 'safety-wear' ),
            'priority' => 20,
            'capability' => 'edit_theme_options',
            'panel' => 'safety_wear_general_settings',
        )
    );

    /** Scroll to top Responsive control */
    $wp_customize->add_setting( 
        'safety_wear_resp_scroll_top', 
        array(
            'default' => 1,
            'sanitize_callback' => 'safety_wear_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'safety_wear_resp_scroll_top',
        array(
            'label'       => __( 'Show Scroll To Top', 'safety-wear' ),
            'section'     => 'safety_wear_responsive_media_section',
            'type'        => 'checkbox',
        )
    );

        /** Scroll to top Responsive control */
    $wp_customize->add_setting( 
        'safety_wear_resp_loader', 
        array(
            'default' => 0,
            'sanitize_callback' => 'safety_wear_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'safety_wear_resp_loader',
        array(
            'label'       => __( 'Show Preloader', 'safety-wear' ),
            'section'     => 'safety_wear_responsive_media_section',
            'type'        => 'checkbox',
        )
    );

    /** Responsive Media Ends */

    //Global Color
    $wp_customize->add_section(
        'safety_wear_global_color',
        array(
            'title' => esc_html__( 'Global Color Settings', 'safety-wear' ),
            'priority' => 20,
            'capability' => 'edit_theme_options',
            'panel' => 'safety_wear_general_settings',
        )
    );

    $wp_customize->add_setting('safety_wear_primary_color', array(
        'default'           => '#ff5e3a',
        'sanitize_callback' => 'sanitize_hex_color',
    ));
    $wp_customize->add_control(new WP_Customize_Color_Control($wp_customize, 'safety_wear_primary_color', array(
        'label'    => __('Theme Primary Color', 'safety-wear'),
        'section'  => 'safety_wear_global_color',
        'settings' => 'safety_wear_primary_color',
    )));    

    /** Post Layouts */

    /** Post & Pages Settings */
    $wp_customize->add_panel( 
        'safety_wear_post_settings',
         array(
            'priority' => 40,
            'capability' => 'edit_theme_options',
            'title' => esc_html__( 'Post & Pages Settings', 'safety-wear' ),
            'description' => esc_html__( 'Customize Post & Pages Settings', 'safety-wear' ),
        ) 
    );
    
    $wp_customize->add_section(
        'safety_wear_post_layout_section',
        array(
            'title' => esc_html__( 'Post Layout Settings', 'safety-wear' ),
            'priority' => 20,
            'capability' => 'edit_theme_options',
            'panel' => 'safety_wear_post_settings',
        )
    );

    $wp_customize->add_setting('safety_wear_post_layout_setting', array(
        'default'           => 'right-sidebar',
        'sanitize_callback' => 'safety_wear_sanitize_post_layout',
    ));

    $wp_customize->add_control('safety_wear_post_layout_setting', array(
        'label'    => __('Post Column Settings', 'safety-wear'),
        'section'  => 'safety_wear_post_layout_section',
        'settings' => 'safety_wear_post_layout_setting',
        'type'     => 'select',
        'choices'  => array(        
            'right-sidebar'   => __('Right Sidebar', 'safety-wear'),
            'left-sidebar'   => __('Left Sidebar', 'safety-wear'),
            'one-column'   => __('One Column', 'safety-wear'),
            'three-column'   => __('Three Columns', 'safety-wear'),
            'four-column'   => __('Four Columns', 'safety-wear'),
            'grid-layout'   => __('Grid Layout', 'safety-wear')
        ),
    ));

    $wp_customize->add_setting('safety_wear_archive_pagination_alignment',array(
        'default' => 'left-align',
        'sanitize_callback' => 'safety_wear_sanitize_pagination_alignment'
    ));
    $wp_customize->add_control('safety_wear_archive_pagination_alignment',array(
        'type' => 'select',
        'label' => __('Pagination Alignment','safety-wear'),
        'section' => 'safety_wear_post_layout_section',
        'choices' => array(
            'right-align' => __('Right Alignment','safety-wear'),
            'center-align' => __('Center Alignment','safety-wear'),
            'left-align' => __('Left Alignment','safety-wear'),
        ),
    ) );

     /** Post Layouts Ends */

    /** Post Settings */
    $wp_customize->add_section(
        'safety_wear_post_settings',
        array(
            'title' => esc_html__( 'Post Settings', 'safety-wear' ),
            'priority' => 20,
            'capability' => 'edit_theme_options',
            'panel' => 'safety_wear_post_settings',
        )
    );

    // Excerpt Length
    $wp_customize->add_section(
        'safety_wear_post_excerpt_length', 
        array(    
            'title'       => __('Excerpt Length', 'safety-wear'),
            'panel' => 'safety_wear_post_settings',   
        )
    );

    $wp_customize->add_setting( 
        'safety_wear_post_excerpt_length', 
        array(
            'default'           => '50',
            'sanitize_callback' => 'safety_wear_sanitize_number_range',
    ) );
    $wp_customize->add_control( 
        'safety_wear_post_excerpt_length', 
        array(
            'label'       => esc_html__( 'Excerpt Length', 'safety-wear' ),
            'section'     => 'safety_wear_post_settings',
            'type'        => 'number',
            'input_attrs' => array( 'min' => 1, 'max' => 200, 'style' => 'width: 100%;' ),
    ) );

    /** Post Heading control */
    $wp_customize->add_setting( 
        'safety_wear_post_heading_setting', 
        array(
            'default'           => true,
            'sanitize_callback' => 'safety_wear_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'safety_wear_post_heading_setting',
        array(
            'label'       => __( 'Show / Hide Post Heading', 'safety-wear' ),
            'section'     => 'safety_wear_post_settings',
            'type'        => 'checkbox',
        )
    );

    /** Post Meta control */
    $wp_customize->add_setting( 
        'safety_wear_post_meta_setting', 
        array(
            'default'           => true,
            'sanitize_callback' => 'safety_wear_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'safety_wear_post_meta_setting',
        array(
            'label'       => __( 'Show / Hide Post Meta', 'safety-wear' ),
            'section'     => 'safety_wear_post_settings',
            'type'        => 'checkbox',
        )
    );

    /** Post Image control */
    $wp_customize->add_setting( 
        'safety_wear_post_image_setting', 
        array(
            'default'           => true,
            'sanitize_callback' => 'safety_wear_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'safety_wear_post_image_setting',
        array(
            'label'       => __( 'Show / Hide Post Image', 'safety-wear' ),
            'section'     => 'safety_wear_post_settings',
            'type'        => 'checkbox',
        )
    );

    /** Post Content control */
    $wp_customize->add_setting( 
        'safety_wear_post_content_setting', 
        array(
            'default'           => true,
            'sanitize_callback' => 'safety_wear_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'safety_wear_post_content_setting',
        array(
            'label'       => __( 'Show / Hide Post Content', 'safety-wear' ),
            'section'     => 'safety_wear_post_settings',
            'type'        => 'checkbox',
        )
    );

    $wp_customize->add_setting( 'safety_wear_read_more_setting', array(
        'default'           => true,
        'sanitize_callback' => 'wp_validate_boolean',
    ) );
    $wp_customize->add_control( 'safety_wear_read_more_setting', array(
        'type'        => 'checkbox',
        'label'       => __( 'Display Read More Button', 'safety-wear' ),
        'section'     => 'safety_wear_post_settings',
        'settings'    => 'safety_wear_read_more_setting',
    ) );

    $wp_customize->add_setting('safety_wear_single_post_align',array(
        'default' => 'left-align',
        'sanitize_callback' => 'safety_wear_sanitize_post_content_align'
    ));
    $wp_customize->add_control('safety_wear_single_post_align',array(
        'type' => 'select',
        'label' => __('Post Content Alignment','safety-wear'),
        'section' => 'safety_wear_post_settings',
        'choices' => array(
            'left-align' => __('Left Alignment','safety-wear'),
            'right-align' => __('Right Alignment','safety-wear'),
            'center-align' => __('Center Alignment','safety-wear'),
        ),
    ) );

    $wp_customize->add_setting('safety_wear_blog_meta_order', array(
        'default' => array('heading', 'author', 'featured-image', 'content','button'),
        'sanitize_callback' => 'safety_wear_sanitize_sortable',
    ));
    $wp_customize->add_control(new Safety_Wear_Control_Sortable($wp_customize, 'safety_wear_blog_meta_order', array(
        'label' => esc_html__('Post Meta Ordering', 'safety-wear'),
        'description' => __('Drag & drop post items to rearrange the ordering ( this control will not function by post format )', 'safety-wear') ,
        'section' => 'safety_wear_post_settings',
        'choices' => array(
            'heading' => __('heading', 'safety-wear') ,
            'author' => __('author', 'safety-wear') ,
            'featured-image' => __('featured-image', 'safety-wear') ,
            'content' => __('content', 'safety-wear') ,
            'button' => __('button', 'safety-wear') ,
        ) ,
    )));
    
    /** Post Settings Ends */

    /** Single Post Settings */
    $wp_customize->add_section(
        'safety_wear_single_post_settings',
        array(
            'title' => esc_html__( 'Single Post Settings', 'safety-wear' ),
            'priority' => 20,
            'capability' => 'edit_theme_options',
            'panel' => 'safety_wear_post_settings',
        )
    );

    /** Single Post Meta control */
    $wp_customize->add_setting( 
        'safety_wear_single_post_meta_setting', 
        array(
            'default'           => true,
            'sanitize_callback' => 'safety_wear_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'safety_wear_single_post_meta_setting',
        array(
            'label'       => __( 'Show / Hide Single Post Meta', 'safety-wear' ),
            'section'     => 'safety_wear_single_post_settings',
            'type'        => 'checkbox',
        )
    );

    /** Single Post Content control */
    $wp_customize->add_setting( 
        'safety_wear_single_post_content_setting', 
        array(
            'default'           => true,
            'sanitize_callback' => 'safety_wear_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'safety_wear_single_post_content_setting',
        array(
            'label'       => __( 'Show / Hide Single Post Content', 'safety-wear' ),
            'section'     => 'safety_wear_single_post_settings',
            'type'        => 'checkbox',
        )
    );

    /** Single Post Settings Ends */

        // Typography Settings Section
    $wp_customize->add_section('safety_wear_typography_settings', array(
        'title'      => esc_html__('Typography Settings', 'safety-wear'),
        'priority'   => 30,
        'capability' => 'edit_theme_options',
        'panel' => 'safety_wear_general_settings',
    ));

    // Array of fonts to choose from
    $font_choices = array(
        ''               => __('Select', 'safety-wear'),
        'Arial'          => 'Arial, sans-serif',
        'Verdana'        => 'Verdana, sans-serif',
        'Helvetica'      => 'Helvetica, sans-serif',
        'Times New Roman'=> '"Times New Roman", serif',
        'Georgia'        => 'Georgia, serif',
        'Courier New'    => '"Courier New", monospace',
        'Trebuchet MS'   => '"Trebuchet MS", sans-serif',
        'Tahoma'         => 'Tahoma, sans-serif',
        'Palatino'       => '"Palatino Linotype", serif',
        'Garamond'       => 'Garamond, serif',
        'Impact'         => 'Impact, sans-serif',
        'Comic Sans MS'  => '"Comic Sans MS", cursive, sans-serif',
        'Lucida Sans'    => '"Lucida Sans Unicode", sans-serif',
        'Arial Black'    => '"Arial Black", sans-serif',
        'Gill Sans'      => '"Gill Sans", sans-serif',
        'Segoe UI'       => '"Segoe UI", sans-serif',
        'Open Sans'      => '"Open Sans", sans-serif',
        'Roboto'         => 'Roboto, sans-serif',
        'Lato'           => 'Lato, sans-serif',
        'Montserrat'     => 'Montserrat, sans-serif',
        'Libre Baskerville' => 'Libre Baskerville',
    );

    // Heading Font Setting
    $wp_customize->add_setting('safety_wear_heading_font_family', array(
        'default'           => '',
        'sanitize_callback' => 'safety_wear_sanitize_choicess',
    ));
    $wp_customize->add_control('safety_wear_heading_font_family', array(
        'type'    => 'select',
        'choices' => $font_choices,
        'label'   => __('Select Font for Heading', 'safety-wear'),
        'section' => 'safety_wear_typography_settings',
    ));

    // Body Font Setting
    $wp_customize->add_setting('safety_wear_body_font_family', array(
        'default'           => '',
        'sanitize_callback' => 'safety_wear_sanitize_choicess',
    ));
    $wp_customize->add_control('safety_wear_body_font_family', array(
        'type'    => 'select',
        'choices' => $font_choices,
        'label'   => __('Select Font for Body', 'safety-wear'),
        'section' => 'safety_wear_typography_settings',
    ));

    /** Typography Settings Section End */

    /** General Settings */
    $wp_customize->add_panel( 
        'safety_wear_general_settings',
         array(
            'priority' => 40,
            'capability' => 'edit_theme_options',
            'title' => esc_html__( 'General Settings', 'safety-wear' ),
            'description' => esc_html__( 'Customize General Settings', 'safety-wear' ),
        ) 
    );

    /** General Settings */
    $wp_customize->add_section(
        'safety_wear_general_settings',
        array(
            'title' => esc_html__( 'Loader Settings', 'safety-wear' ),
            'priority' => 20,
            'capability' => 'edit_theme_options',
            'panel' => 'safety_wear_general_settings',
        )
    );

     /** Preloader control */
     $wp_customize->add_setting( 
        'safety_wear_preloader_setting', 
        array(
            'default'           => false,
            'sanitize_callback' => 'safety_wear_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'safety_wear_preloader_setting',
        array(
            'label'       => __( 'Show / Hide Preloader', 'safety-wear' ),
            'section'     => 'safety_wear_general_settings',
            'type'        => 'checkbox',
        )
    );


    $wp_customize->add_setting('safety_wear_theme_width',array(
        'default' => 'full-width',
        'sanitize_callback' => 'safety_wear_sanitize_theme_width'
    ));
    $wp_customize->add_control('safety_wear_theme_width',array(
        'type' => 'select',
        'label' => __('Theme Width Option','safety-wear'),
        'section' => 'safety_wear_general_settings',
        'choices' => array(
            'full-width' => __('Fullwidth','safety-wear'),
            'container' => __('Container','safety-wear'),
            'container-fluid' => __('Container Fluid','safety-wear'),
        ),
    ) );


    /** General Settings Ends */

    /** Header Section Settings */
    $wp_customize->add_section(
        'safety_wear_header_section_settings',
        array(
            'title' => esc_html__( 'Header Section Settings', 'safety-wear' ),
            'priority' => 30,
            'capability' => 'edit_theme_options',
            'panel' => 'safety_wear_home_page_settings',
        )
    );

    /** Header Section control */
    $wp_customize->add_setting( 
        'safety_wear_header_setting', 
        array(
            'default' => false ,
            'sanitize_callback' => 'safety_wear_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'safety_wear_header_setting',
        array(
            'label'       => __( 'Show Header', 'safety-wear' ),
            'section'     => 'safety_wear_header_section_settings',
            'type'        => 'checkbox',
        )
    );

     /** Phone */
    $wp_customize->add_setting(
        'safety_wear_header_phone',
        array( 
            'default' => '',
            'sanitize_callback' => 'sanitize_text_field',
            'transport'         => 'refresh'
        )
    );
    
    $wp_customize->add_control(
        'safety_wear_header_phone',
        array(
            'label' => esc_html__( 'Add Phone', 'safety-wear' ),
            'section' => 'safety_wear_header_section_settings',
            'type' => 'text',
        )
    );

    $wp_customize->add_setting('safety_wear_phone_icon',array(
        'default'   => 'fas fa-phone',
        'sanitize_callback' => 'sanitize_text_field'
    ));
    $wp_customize->add_control(new Safety_Wear_Changeable_Icon(
        $wp_customize,'safety_wear_phone_icon',array(
        'label' => __('Phone Icon','safety-wear'),
        'transport' => 'refresh',
        'section'   => 'safety_wear_header_section_settings',
        'type'      => 'icon'
    )));


     /** Email */
    $wp_customize->add_setting(
        'safety_wear_header_email',
        array( 
            'default' => '',
            'sanitize_callback' => 'sanitize_text_field',
            'transport'         => 'refresh'
        )
    );
    
    $wp_customize->add_control(
        'safety_wear_header_email',
        array(
            'label' => esc_html__( 'Add Email', 'safety-wear' ),
            'section' => 'safety_wear_header_section_settings',
            'type' => 'text',
        )
    );


    $wp_customize->add_setting('safety_wear_mail_icon',array(
        'default'   => 'fas fa-envelope',
        'sanitize_callback' => 'sanitize_text_field'
    ));
    $wp_customize->add_control(new Safety_Wear_Changeable_Icon(
        $wp_customize,'safety_wear_mail_icon',array(
        'label' => __('Mail Icon','safety-wear'),
        'transport' => 'refresh',
        'section'   => 'safety_wear_header_section_settings',
        'type'      => 'icon'
    )));


   
 /**  Timing */
    $wp_customize->add_setting(
        'safety_wear_header_timing',
        array( 
            'default' => '',
            'sanitize_callback' => 'sanitize_text_field',
            'transport'         => 'refresh'
        )
    );
    
    $wp_customize->add_control(
        'safety_wear_header_timing',
        array(
            'label' => esc_html__( 'Add Date & Timing', 'safety-wear' ),
            'section' => 'safety_wear_header_section_settings',
            'type' => 'text',
        )
    );


    $wp_customize->add_setting('safety_wear_clock_icon',array(
        'default'   => 'far fa-clock',
        'sanitize_callback' => 'sanitize_text_field'
    ));
    $wp_customize->add_control(new Safety_Wear_Changeable_Icon(
        $wp_customize,'safety_wear_clock_icon',array(
        'label' => __('Time Icon','safety-wear'),
        'transport' => 'refresh',
        'section'   => 'safety_wear_header_section_settings',
        'type'      => 'icon'
    )));

     /** Sticky Header control */
     $wp_customize->add_setting( 
        'safety_wear_sticky_header', 
        array(
            'default' => false,
            'sanitize_callback' => 'safety_wear_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'safety_wear_sticky_header',
        array(
            'label'       => __( 'Show Sticky Header', 'safety-wear' ),
            'section'     => 'safety_wear_header_section_settings',
            'type'        => 'checkbox',
        )
    );

     /** Slider Section control */
    $wp_customize->add_setting( 
        'safety_wear_show_hide_search', 
        array(
            'default' => false ,
            'sanitize_callback' => 'safety_wear_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'safety_wear_show_hide_search',
        array(
            'label'       => __( 'Show Search Icon', 'safety-wear' ),
            'section'     => 'safety_wear_header_section_settings',
            'type'        => 'checkbox',
        )
    );

    // Add Setting for Menu Font Weight
    $wp_customize->add_setting( 'safety_wear_menu_font_weight', array(
        'default'           => '500',
        'sanitize_callback' => 'safety_wear_sanitize_font_weight',
    ) );

    // Add Control for Menu Font Weight
    $wp_customize->add_control( 'safety_wear_menu_font_weight', array(
        'label'    => __( 'Menu Font Weight', 'safety-wear' ),
        'section'  => 'safety_wear_header_section_settings',
        'type'     => 'select',
        'choices'  => array(
            '100' => __( '100 - Thin', 'safety-wear' ),
            '200' => __( '200 - Extra Light', 'safety-wear' ),
            '300' => __( '300 - Light', 'safety-wear' ),
            '400' => __( '400 - Normal', 'safety-wear' ),
            '500' => __( '500 - Medium', 'safety-wear' ),
            '600' => __( '600 - Semi Bold', 'safety-wear' ),
            '700' => __( '700 - Bold', 'safety-wear' ),
            '800' => __( '800 - Extra Bold', 'safety-wear' ),
            '900' => __( '900 - Black', 'safety-wear' ),
        ),
    ) );

    // Add Setting for Menu Text Transform
    $wp_customize->add_setting( 'safety_wear_menu_text_transform', array(
        'default'           => 'capitalize',
        'sanitize_callback' => 'safety_wear_sanitize_text_transform',
    ) );

    // Add Control for Menu Text Transform
    $wp_customize->add_control( 'safety_wear_menu_text_transform', array(
        'label'    => __( 'Menu Text Transform', 'safety-wear' ),
        'section'  => 'safety_wear_header_section_settings',
        'type'     => 'select',
        'choices'  => array(
            'none'       => __( 'None', 'safety-wear' ),
            'capitalize' => __( 'Capitalize', 'safety-wear' ),
            'uppercase'  => __( 'Uppercase', 'safety-wear' ),
            'lowercase'  => __( 'Lowercase', 'safety-wear' ),
        ),
    ) );

    $wp_customize->add_setting('safety_wear_menus_style',array(
        'default' => '',
        'sanitize_callback' => 'safety_wear_sanitize_choices'
	));
	$wp_customize->add_control('safety_wear_menus_style',array(
        'type' => 'select',
		'label' => __('Menu Hover Style','safety-wear'),
		'section' => 'safety_wear_header_section_settings',
		'choices' => array(
         'None' => __('None','safety-wear'),
         'Zoom In' => __('Zoom In','safety-wear'),
      ),
	));
   
    /** Header Section Settings End */

    /** Socail Section Settings */
    $wp_customize->add_section(
        'safety_wear_social_section_settings',
        array(
            'title' => esc_html__( 'Social Media Section Settings', 'safety-wear' ),
            'priority' => 30,
            'capability' => 'edit_theme_options',
            'panel' => 'safety_wear_home_page_settings',
        )
    );

    /** Socail Section control */
    $wp_customize->add_setting( 
        'safety_wear_social_icon_setting', 
        array(
            'default' => false,
            'sanitize_callback' => 'safety_wear_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'safety_wear_social_icon_setting',
        array(
            'label'       => __( 'Show Social Icon', 'safety-wear' ),
            'section'     => 'safety_wear_social_section_settings',
            'type'        => 'checkbox',
        )
    );

    /**  Social Link 1 */
    $wp_customize->add_setting(
        'safety_wear_social_link_1',
        array( 
            'default' => '',
            'sanitize_callback' => 'esc_url_raw',
            'transport'         => 'refresh'
        )
    );
    
    $wp_customize->add_control(
        'safety_wear_social_link_1',
        array(
            'label' => esc_html__( 'Add Facebook Link', 'safety-wear' ),
            'section' => 'safety_wear_social_section_settings',
            'type' => 'url',
        )
    );

    /**  Social Link 2 */
    $wp_customize->add_setting(
        'safety_wear_social_link_2',
        array( 
            'default' => '',
            'sanitize_callback' => 'esc_url_raw',
            'transport'         => 'refresh'
        )
    );
    
    $wp_customize->add_control(
        'safety_wear_social_link_2',
        array(
            'label' => esc_html__( 'Add Twitter Link', 'safety-wear' ),
            'section' => 'safety_wear_social_section_settings',
            'type' => 'url',
        )
    );

    /**  Social Link 3 */
    $wp_customize->add_setting(
        'safety_wear_social_link_3',
        array( 
            'default' => '',
            'sanitize_callback' => 'esc_url_raw',
            'transport'         => 'refresh'
        )
    );
    
    $wp_customize->add_control(
        'safety_wear_social_link_3',
        array(
            'label' => esc_html__( 'Add Instagram Link', 'safety-wear' ),
            'section' => 'safety_wear_social_section_settings',
            'type' => 'url',
        )
    );

    /**  Social Link 4 */
    $wp_customize->add_setting(
        'safety_wear_social_link_4',
        array( 
            'default' => '',
            'sanitize_callback' => 'esc_url_raw',
            'transport'         => 'refresh'
        )
    );
    
    $wp_customize->add_control(
        'safety_wear_social_link_4',
        array(
            'label' => esc_html__( 'Add Pintrest Link', 'safety-wear' ),
            'section' => 'safety_wear_social_section_settings',
            'type' => 'url',
        )
    );


    /** Social Section Settings End */

    /** Home Page Settings */
    $wp_customize->add_panel( 
        'safety_wear_home_page_settings',
         array(
            'priority' => 9,
            'capability' => 'edit_theme_options',
            'title' => esc_html__( 'Home Page Settings', 'safety-wear' ),
            'description' => esc_html__( 'Customize Home Page Settings', 'safety-wear' ),
        ) 
    );

    /** Slider Section Settings */
    $wp_customize->add_section(
        'safety_wear_slider_section_settings',
        array(
            'title' => esc_html__( 'Slider Section Settings', 'safety-wear' ),
            'priority' => 30,
            'capability' => 'edit_theme_options',
            'panel' => 'safety_wear_home_page_settings',
        )
    );

    /** Slider Section control */
    $wp_customize->add_setting( 
        'safety_wear_slider_setting', 
        array(
            'default' => false ,
            'sanitize_callback' => 'safety_wear_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'safety_wear_slider_setting',
        array(
            'label'       => __( 'Show Slider', 'safety-wear' ),
            'section'     => 'safety_wear_slider_section_settings',
            'type'        => 'checkbox',
        )
    );

    // Section Text
    $wp_customize->add_setting('safety_wear_slider_text_extra', 
        array(
        'default'           => '',
        'type'              => 'theme_mod',
        'capability'        => 'edit_theme_options',    
        'sanitize_callback' => 'sanitize_text_field'
        )
    );

    $wp_customize->add_control('safety_wear_slider_text_extra', 
        array(
        'label'       => __('Slider Extra Title', 'safety-wear'),
        'section'     => 'safety_wear_slider_section_settings',   
        'settings'    => 'safety_wear_slider_text_extra',
        'type'        => 'text'
        )
    );
    
    $categories = get_categories();
        $cat_posts = array();
            $i = 0;
            $cat_posts[]='Select';
        foreach($categories as $category){
            if($i==0){
            $default = $category->slug;
            $i++;
        }
        $cat_posts[$category->slug] = $category->name;
    }

    $wp_customize->add_setting(
        'safety_wear_blog_slide_category',
        array(
            'default'   => 'select',
            'sanitize_callback' => 'safety_wear_sanitize_choices',
        )
    );
    $wp_customize->add_control(
        'safety_wear_blog_slide_category',
        array(
            'type'    => 'select',
            'choices' => $cat_posts,
            'label' => __('Select Category to display Slider Post','safety-wear'),
            'section' => 'safety_wear_slider_section_settings',
        )
    );

    /** Slider Section control */
    $wp_customize->add_setting( 
        'safety_wear_slider_button_1_setting', 
        array(
            'default' => true ,
            'sanitize_callback' => 'safety_wear_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'safety_wear_slider_button_1_setting',
        array(
            'label'       => __( 'Show Slider Button 1', 'safety-wear' ),
            'section'     => 'safety_wear_slider_section_settings',
            'type'        => 'checkbox',
        )
    );

    // Section Text
    $wp_customize->add_setting('safety_wear_slider_second_button_url', 
        array(
        'default'           => '',
        'type'              => 'theme_mod',
        'capability'        => 'edit_theme_options',    
        'sanitize_callback' => 'sanitize_text_field'
        )
    );

    $wp_customize->add_control('safety_wear_slider_second_button_url', 
        array(
        'label'       => __('Slider Second Button URL', 'safety-wear'),
        'section'     => 'safety_wear_slider_section_settings',   
        'settings'    => 'safety_wear_slider_second_button_url',
        'type'        => 'url'
        )
    );

    /** About Section Settings */
    
    $wp_customize->add_section( 'safety_wear_section_featured_about',
        array(
        'title'      => __( 'Safety Gear Section', 'safety-wear' ),
        'priority'   => 110,
        'capability' => 'edit_theme_options',
        'panel'      => 'safety_wear_home_page_settings',
        )
    );

    /** Safety Gear Section control */
    $wp_customize->add_setting( 
        'safety_wear_about_setting', 
        array(
            'default' => false ,
            'sanitize_callback' => 'safety_wear_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'safety_wear_about_setting',
        array(
            'label'       => __( 'Show Safety Gear', 'safety-wear' ),
            'section'     => 'safety_wear_section_featured_about',
            'type'        => 'checkbox',
        )
    );

    // Section Title
    $wp_customize->add_setting('safety_wear_featured_mission_section_title', 
        array(
        'capability'        => 'edit_theme_options',    
        'sanitize_callback' => 'sanitize_text_field'
        )
    );

    $wp_customize->add_control('safety_wear_featured_mission_section_title', 
        array(
        'label'       => __('Section Title', 'safety-wear'),
        'section'     => 'safety_wear_section_featured_about',   
        'settings'    => 'safety_wear_featured_mission_section_title',
        'type'        => 'text'
        )
    );

    // Items
    $wp_customize->add_setting('safety_wear_number_of_featured_mission_items', 
        array(
        'default'           => '',
        'capability'        => 'edit_theme_options',    
        'sanitize_callback' => 'safety_wear_sanitize_number_range'
        )
    );

    $wp_customize->add_control('safety_wear_number_of_featured_mission_items', 
        array(
        'label'       => __('Items (Max: 6)', 'safety-wear'),
        'section'     => 'safety_wear_section_featured_about',   
        'settings'    => 'safety_wear_number_of_featured_mission_items',
        'type'        => 'number',
        'input_attrs' => array(
                'min'   => 1,
                'max'   => 6,
                'step'  => 1,
            ),
        )
    );

 $safety_wear_number_of_featured_mission_items = get_theme_mod( 'safety_wear_number_of_featured_mission_items' );

for ($item_index = 1; $item_index <= $safety_wear_number_of_featured_mission_items; $item_index++) {

    // Section Tab
    $wp_customize->add_setting('safety_wear_featured_mission_section_tab_' . $item_index, 
        array(  
            'capability'        => 'edit_theme_options',
            'sanitize_callback' => 'sanitize_text_field'
        )
    );

    $wp_customize->add_control('safety_wear_featured_mission_section_tab_' . $item_index, 
        array(
            'label'       => __('Tab ', 'safety-wear') . $item_index,
            'section'     => 'safety_wear_section_featured_about',
            'settings'    => 'safety_wear_featured_mission_section_tab_' . $item_index,
            'type'        => 'text'
        )
    );

    // Post Categories
    $categories = get_categories();
    $cat_posts = array();
    $default = '';
    $cat_posts[] = 'Select';
    foreach ($categories as $category) {
        $cat_posts[$category->slug] = $category->name;
    }

    $wp_customize->add_setting(
        'safety_wear_trending_post_slider_args_' . $item_index,
        array(
            'default'            => 'select',
            'sanitize_callback'  => 'safety_wear_sanitize_choices',
        )
    );
    $wp_customize->add_control(
        'safety_wear_trending_post_slider_args_' . $item_index,
        array(
            'type'     => 'select',
            'choices'  => $cat_posts,
            'label'    => __('Select Category to display Tab Details', 'safety-wear'),
            'section'  => 'safety_wear_section_featured_about',
        )
    );
}
    
    /** Home Page Settings Ends */
    
    /** Footer Section */
    $wp_customize->add_section(
        'safety_wear_footer_section',
        array(
            'title' => __( 'Footer Settings', 'safety-wear' ),
            'priority' => 70,
            'panel' => 'safety_wear_home_page_settings',
        )
    );

    /** Footer Widget Columns */
    $wp_customize->add_setting('safety_wear_footer_widget_areas', array(
        'default'           => 4,
        'sanitize_callback' => 'safety_wear_sanitize_choices',
    ));

    $wp_customize->add_control('safety_wear_footer_widget_areas', array(
        'label'    => __('Footer Widget Columns', 'safety-wear'),
        'section'  => 'safety_wear_footer_section',
        'settings' => 'safety_wear_footer_widget_areas',
        'type'     => 'select',
        'choices'  => array(
		   '1'     => __('One', 'safety-wear'),
		   '2'     => __('Two', 'safety-wear'),
		   '3'     => __('Three', 'safety-wear'),
		   '4'     => __('Four', 'safety-wear')
        ),
    ));

    /** Copyright Text */
    $wp_customize->add_setting(
        'safety_wear_footer_copyright_text',
        array(
            'default' => '',
            'sanitize_callback' => 'sanitize_text_field',
        )
    );
    
    $wp_customize->add_control(
        'safety_wear_footer_copyright_text',
        array(
            'label' => __( 'Copyright Info', 'safety-wear' ),
            'section' => 'safety_wear_footer_section',
            'type' => 'text',
        )
    );

    /* Footer Background Color*/
    $wp_customize->add_setting(
        'footer_background_color',
        array(
            'default' => '',
            'sanitize_callback' => 'sanitize_hex_color',
        )
    );
    $wp_customize->add_control(
        new WP_Customize_Color_Control(
            $wp_customize,
            'footer_background_color',
            array(
                'label' => __('Footer Widget Area Background Color', 'safety-wear'),
                'section' => 'safety_wear_footer_section',
                'type' => 'color',
            )
        )
    );

    $wp_customize->add_setting('footer_background_image',
        array(
        'default' => '',
        'capability' => 'edit_theme_options',
        'sanitize_callback' => 'absint',
        )
    );


    $wp_customize->add_control(
         new WP_Customize_Cropped_Image_Control($wp_customize, 'footer_background_image',
            array(
                'label' => esc_html__('Footer Background Image', 'safety-wear'),
                /* translators: 1: image width in pixels, 2: image height in pixels */
                'description' => sprintf(esc_html__('Recommended Size %1$s px X %2$s px', 'safety-wear'), 1024, 800),
                'section' => 'safety_wear_footer_section',
                'width' => 1024,
                'height' => 800,
                'flex_width' => true,
                'flex_height' => true,
            )
        )
    );

    /** Footer Background Image Attachment */
    $wp_customize->add_setting('safety_wear_background_attatchment', array(
        'default'           => 'scroll',
        'sanitize_callback' => 'safety_wear_sanitize_choices',
    ));

    $wp_customize->add_control('safety_wear_background_attatchment', array(
        'label'    => __('Footer Background Attachment', 'safety-wear'),
        'section'  => 'safety_wear_footer_section',
        'settings' => 'safety_wear_background_attatchment',
        'type'     => 'select',
        'choices'  => array(
            'fixed' => __('fixed','safety-wear'),
            'scroll' => __('scroll','safety-wear'),
        ),
    ));

    /** Scroll To Top control */
    $wp_customize->add_setting( 
        'safety_wear_footer_scroll_to_top', 
        array(
            'default'           => true,
            'sanitize_callback' => 'safety_wear_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'safety_wear_footer_scroll_to_top',
        array(
            'label'       => __( 'Show / Hide Scroll To Top', 'safety-wear' ),
            'section'     => 'safety_wear_footer_section',
            'type'        => 'checkbox',
        )
    );

    $wp_customize->add_setting('safety_wear_scroll_icon',array(
        'default'   => 'fas fa-arrow-up',
        'sanitize_callback' => 'sanitize_text_field'
    ));
    $wp_customize->add_control(new Safety_Wear_Changeable_Icon(
        $wp_customize,'safety_wear_scroll_icon',array(
        'label' => __('Scroll Top Icon','safety-wear'),
        'transport' => 'refresh',
        'section'   => 'safety_wear_footer_section',
        'type'      => 'icon'
    )));

    $wp_customize->add_setting('safety_wear_scroll_top_alignment',array(
        'default' => 'right-align',
        'sanitize_callback' => 'safety_wear_sanitize_scroll_top_alignment'
    ));
    $wp_customize->add_control('safety_wear_scroll_top_alignment',array(
        'type' => 'select',
        'label' => __('Scroll Top Alignment','safety-wear'),
        'section' => 'safety_wear_footer_section',
        'choices' => array(
            'right-align' => __('Right Alignment','safety-wear'),
            'center-align' => __('Center Alignment','safety-wear'),
            'left-align' => __('Left Alignment','safety-wear'),
        ),
    ) );

    /** Scroll to top button shape */
    $wp_customize->add_setting('safety_wear_scroll_to_top_radius', array(
        'default'           => 'curved-box',
        'sanitize_callback' => 'safety_wear_sanitize_choices',
    ));

    $wp_customize->add_control('safety_wear_scroll_to_top_radius', array(
        'label'    => __('Scroll Top Button Shape', 'safety-wear'),
        'section'  => 'safety_wear_footer_section',
        'settings' => 'safety_wear_scroll_to_top_radius',
        'type'     => 'select',
        'choices'  => array(
            'box'        => __( 'Box', 'safety-wear' ),
            'curved-box' => __( 'Curved Box', 'safety-wear' ),
            'circle'     => __( 'Circle', 'safety-wear' ),
        ),
    ));

    // 404 PAGE SETTINGS
    $wp_customize->add_section(
        'safety_wear_404_section',
        array(
            'title' => __( '404 Page Settings', 'safety-wear' ),
            'priority' => 70,
            'panel' => 'safety_wear_general_settings',
        )
    );
   
    $wp_customize->add_setting('404_page_image', array(
        'default' => '',
        'transport' => 'refresh',
        'sanitize_callback' => 'esc_url_raw', // Sanitize as URL
    ));

    $wp_customize->add_control(new WP_Customize_Image_Control($wp_customize, '404_page_image', array(
        'label' => __('404 Page Image', 'safety-wear'),
        'section' => 'safety_wear_404_section',
        'settings' => '404_page_image',
    )));

    $wp_customize->add_setting('404_pagefirst_header', array(
        'default' => __('404', 'safety-wear'),
        'transport' => 'refresh',
        'sanitize_callback' => 'sanitize_text_field', // Sanitize as text field
    ));

    $wp_customize->add_control('404_pagefirst_header', array(
        'type' => 'text',
        'label' => __('Heading', 'safety-wear'),
        'section' => 'safety_wear_404_section',
    ));

    // Setting for 404 page header
    $wp_customize->add_setting('404_page_header', array(
        'default' => __('Sorry, that page can\'t be found!', 'safety-wear'),
        'transport' => 'refresh',
        'sanitize_callback' => 'sanitize_text_field', // Sanitize as text field
    ));

    $wp_customize->add_control('404_page_header', array(
        'type' => 'text',
        'label' => __('Heading', 'safety-wear'),
        'section' => 'safety_wear_404_section',
    ));
    /** Footer control END */
}
add_action( 'customize_register', 'safety_wear_customize_register' );
endif;

/**
 * Binds JS handlers to make Theme Customizer preview reload changes asynchronously.
 */
function safety_wear_customize_preview_js() {
    // Use minified libraries if SCRIPT_DEBUG is false
    $safety_wear_build  = ( defined( 'SCRIPT_DEBUG' ) && SCRIPT_DEBUG ) ? '/build' : '';
    $safety_wear_suffix = ( defined( 'SCRIPT_DEBUG' ) && SCRIPT_DEBUG ) ? '' : '.min';
	wp_enqueue_script( 'safety_wear_customizer', get_template_directory_uri() . '/js' . $safety_wear_build . '/customizer' . $safety_wear_suffix . '.js', array( 'customize-preview' ), '20130508', true );
}
add_action( 'customize_preview_init', 'safety_wear_customize_preview_js' );